//+------------------------------------------------------------------+
//|                                                   find order.mq4 |
//|                      Copyright  2008, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2008, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"
//------------------
extern   double   dCoeff = 0.38;        // " ",  %  0.01  1 
extern   bool     bTrlinloss = true;  //       (    )
//---------------------
static int prevtime = 0 ;
static datetime sdtPrevtime = 0;
//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
//if (Time[0] == prevtime) return(0);
               // prevtime = Time[0];
                    RefreshRates();  
//----          --------------+ 
int Count;
int ticket;
int TicketOpen;
int total = OrdersTotal(); 
   if (total>0)  
      {
      for (int i=0;i<total;i++)
          {
          OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
          ticket = OrderTicket( ) ;
          if (((OrderType() != 0)||(OrderType() != 1))&&(OrderSymbol()==Symbol())) {Count = i;}
            {
          if (((OrderType() == 0)||(OrderType() == 1))&&(OrderSymbol()==Symbol()))//   
              {
              TicketOpen = ticket;
              for (i=0;i<total;i++)
                  {
                  OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
                  ticket = OrderTicket( ) ;
                  if (OrderSymbol()==Symbol()){OrderDelete(ticket);}//   
                  }
               }
            }  
         }
      }   
Comment("  ="+Count+"\n o  "+TicketOpen);
int      iTmFrme = Period( ) ;           
//----------------------------------------------------------------------------------------------+
   if (Time[0] == prevtime) 
       {
        TrailingFiftyFifty(TicketOpen,iTmFrme, dCoeff, bTrlinloss);
        return(0);
        }
      prevtime = Time[0];
//void KillLoss(int iTicket,double dSpeedCoeff)

   return(0);
  }
//+------------------------------------------------------------------+   
void TrailingFiftyFifty(int iTicket,int iTmFrme,double dCoeff,bool bTrlinloss)
   { 
   //      
   if (sdtPrevtime == iTime(Symbol(),iTmFrme,0)) return(0);
   else
      {
      sdtPrevtime = iTime(Symbol(),iTmFrme,0);             
      
      //   
      if ((iTicket==0) || (!OrderSelect(iTicket,SELECT_BY_TICKET)) || 
      ((iTmFrme!=1) && (iTmFrme!=5) && (iTmFrme!=15) && (iTmFrme!=30) && (iTmFrme!=60) && (iTmFrme!=240) && 
      (iTmFrme!=1440) && (iTmFrme!=10080) && (iTmFrme!=43200)) || (dCoeff<0.01) || (dCoeff>1.0))
         {
         Print("  TrailingFiftyFifty()  -     .");
         return(0);
         }
         
      //   -      (  bTrlinloss     
      //            )
      // ..    ,    OrderOpenTime()    iTmFrme 
      if (iTime(Symbol(),iTmFrme,0)>OrderOpenTime())
      {         
      
      double dBid = MarketInfo(Symbol(),MODE_BID);
      double dAsk = MarketInfo(Symbol(),MODE_ASK);
      double dNewSl;
      double dNexMove;     
      
      //       dCoeff      Bid    
      // (          )
      if (OrderType()==OP_BUY)
         {
         if ((bTrlinloss) && (OrderStopLoss()!=0))
            {
            dNexMove = NormalizeDouble(dCoeff*(dBid-OrderStopLoss()),Digits);
            dNewSl = NormalizeDouble(OrderStopLoss()+dNexMove,Digits);            
            }
         else
            {
            //     ,   "  "
            if (OrderOpenPrice()>OrderStopLoss())
               {
               dNexMove = NormalizeDouble(dCoeff*(dBid-OrderOpenPrice()),Digits);                 
               //Print("dNexMove = ",dCoeff,"*(",dBid,"-",OrderOpenPrice(),")");
               dNewSl = NormalizeDouble(OrderOpenPrice()+dNexMove,Digits);
               //Print("dNewSl = ",OrderOpenPrice(),"+",dNexMove);
               }
         
            //     ,   
            if (OrderStopLoss()>=OrderOpenPrice())
               {
               dNexMove = NormalizeDouble(dCoeff*(dBid-OrderStopLoss()),Digits);
               dNewSl = NormalizeDouble(OrderStopLoss()+dNexMove,Digits);
               }                                      
            }
            
         //     ,         -   
         // (  ,   ,      ,       
         //   ( dBid  ) 
         if ((dNewSl>OrderStopLoss()) && (dNexMove>0) && ((dNewSl<Bid- MarketInfo(Symbol(),MODE_STOPLEVEL)*Point)))
            {
            if (!OrderModify(OrderTicket(),OrderOpenPrice(),dNewSl,OrderTakeProfit(),OrderExpiration(),Red))
            Print("     ",OrderTicket(),". : ",GetLastError());
            }
         }       
      
      //       
      if (OrderType()==OP_SELL)
         {
         if ((bTrlinloss) && (OrderStopLoss()!=0))
            {
            dNexMove = NormalizeDouble(dCoeff*(OrderStopLoss()-(dAsk+MarketInfo(Symbol(),MODE_SPREAD)*Point)),Digits);
            dNewSl = NormalizeDouble(OrderStopLoss()-dNexMove,Digits);            
            }
         else
            {         
            //     ,   "  "
            if (OrderOpenPrice()<OrderStopLoss())
               {
               dNexMove = NormalizeDouble(dCoeff*(OrderOpenPrice()-(dAsk+MarketInfo(Symbol(),MODE_SPREAD)*Point)),Digits);                 
               dNewSl = NormalizeDouble(OrderOpenPrice()-dNexMove,Digits);
               }
         
            //     ,   
            if (OrderStopLoss()<=OrderOpenPrice())
               {
               dNexMove = NormalizeDouble(dCoeff*(OrderStopLoss()-(dAsk+MarketInfo(Symbol(),MODE_SPREAD)*Point)),Digits);
               dNewSl = NormalizeDouble(OrderStopLoss()-dNexMove,Digits);
               }                  
            }
         
         //     ,         -   
         if ((dNewSl<OrderStopLoss()) && (dNexMove>0) && (dNewSl>Ask+MarketInfo(Symbol(),MODE_STOPLEVEL)*Point))
            {
            if (!OrderModify(OrderTicket(),OrderOpenPrice(),dNewSl,OrderTakeProfit(),OrderExpiration(),Blue))
            Print("     ",OrderTicket(),". : ",GetLastError());
            }
         }               
      }
      }   
   }
//+------------------------------------------------------------------+